#include <stdint.h>
#include <avr/pgmspace.h>
#include "globals.h"
#include "main.h"

matrix_t matrix;
matrix_t pattern;
uint8_t  matrix_cal[SIZE];
led_t    leds;     

const uint8_t colors[8][3] PROGMEM = // colors for domes
    //  G    R    B 
    {
    {   0,   0,   0},      // black
    {   0,   0, 255},      // blue
    { 255,   0,   0},      // green
    {   0, 255,   0},      // red
    { 150, 255,   0},      // yellow, green ist too strong
    {   0, 255, 255},      // violett
    { 200,   0, 200},      // turquoise at reduced brightness for better distinction from white
    { 255, 255, 255},      // white
    };    

const uint8_t color_circle[6][4] PROGMEM = // for light show
     // G    R    B   FADING index and direction = color index + 3 (fade++)
     //                                          = color index + 0 (fade--) 
    {
    {   0,   0, 255, 4},      // blue
    {   0, 255, 255, 2},      // violett
    {   0, 255,   0, 3},      // red
    { 255, 255,   0, 1},      // yellow
    { 255,   0,   0, 5},      // green
    { 255,   0, 255, 0}       // turquoise
    };     

const pattern_t patterns[6] PROGMEM =      // base patterns
    {
    // number == touch group    unwanted shifts, numbers >7 are don't care
    { {1, 0, 0, 0, 1, 0, 0, 0}, {0, 4, 8, 8} },   // line
    { {1, 0, 0, 1, 0, 1, 0, 0}, {0, 8, 8, 8} },   // Y
    { {1, 0, 2, 0, 1, 0, 2, 0}, {0, 2, 4, 6} },   // cross
    { {1, 1, 1, 0, 2, 2, 2, 0}, {0, 4, 8, 8} },   // 2x3
    { {1, 1, 1, 2, 3, 3, 3, 2}, {0, 4, 8, 8} },   // butterfly
    { {1, 2, 3, 4, 1, 2, 3, 4}, {8, 8, 8, 8} }    // 4 spiked star, will always generate a rotated pattern
    };

const uint8_t levels[3][GAME_ROUNDS][3] PROGMEM =      // pattern range for levels
    {

    {// difficulty easy
    // min, max, time /0.1s
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {1 , 2, 50},
    {1 , 2, 50},
    {1 , 2, 50},
    {2 , 2, 50},
    },

    {// difficulty medium
    // min, max, time /0.1s
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 2, 50},
    {0 , 2, 50},
    {0 , 2, 50},
    {1 , 3, 50},
    {1 , 3, 50},
    {1 , 3, 50},
    {2 , 4, 50},
    {2 , 4, 50},
    {2 , 4, 50},
    {3 , 5, 50},
    {3 , 5, 50},
    {4 , 5, 50},
    },
    
    {// difficulty hard
    // min, max, time /0.1s
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 0, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {0 , 1, 50},
    {1 , 2, 50},
    {1 , 2, 50},
    {1 , 2, 50},
    {2 , 3, 50},
    {2 , 3, 50},
    {2 , 3, 50},
    {3 , 4, 50},
    {3 , 4, 50},
    {3 , 4, 50},
    {4 , 5, 50},
    {4 , 5, 50},
    {5 , 5, 50},
    }
    };    

const uint8_t menu_select_difficulty[8] PROGMEM =      // menu for difficulty selection
    {YELLOW, RED, BLACK, BLACK, WHITE, BLACK, BLACK, GREEN};

const uint8_t menu_all_colors[8] PROGMEM =      // 
    {BLACK, BLUE, GREEN, RED, YELLOW, VIOLETT, TURQUOISE, WHITE};

volatile uint8_t flag_100ms;    
uint8_t enable_light_show;
    
