#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "main.h"
#include "globals.h"
#include "misc.h"
#include "game.h"
#include "ws2812.h"
#include "test.h"
#include <util/delay.h>

void io_test(void) {
    
    while(1) {
        PORTD ^= (1<<PD6);
        _delay_ms(1000);
    }
}

void led_test(void) {

    while(1) {
        //memset (leds, 0, sizeof(leds));
        //ws2812_write(leds[0], 3, &PORTD, 1<<PD6);
        //update_LEDs(leds);
        game_over_light(0);
        _delay_ms(100);

        //memset (leds, 0xFF, sizeof(leds));
        
        //ws2812_write(leds[0], 3, &PORTD, 1<<PD6);
        //update_LEDs(leds);
        game_over_light(0);
        _delay_ms(100);
    }
}

void test_random(void) {

    char tmp[10];
    int statistics[11];
    int i, j;

    // clear statistics counters

    for (j=0; j<11; j++) {
        statistics[j]=0;
    }

    // generate random numbers and do statistics

    for (j=0; j<10000; j++) {
        i = rand_range(0, 10);
        statistics[i]++;
        itoa(i, tmp, 10);
        //soft_uart_puts(tmp);
        //soft_uart_putc(' ');       
    }

    // print statistica

    soft_uart_puts("\r\nStatistics\r\n");
    for (j=0; j<11; j++) {
        itoa(j, tmp, 10);
        soft_uart_puts(tmp);
        soft_uart_puts(" : ");
        itoa(statistics[j], tmp, 10);
        soft_uart_puts(tmp);
        soft_uart_puts("\r\n");
    }

    for (j=0, i=0; j<11; j++) {
        i+= statistics[j];
    }

    soft_uart_puts("\r\nSum ");
    itoa(i, tmp, 10);
    soft_uart_puts(tmp);
    soft_uart_puts("\r\n");
}

void test_pattern_generation(void) {
    int i, j, k;
    char tmp[20];

    for (i=0; i<3; i++) {   // difficulty
        for (j=0; j<20; j++) {  // level
            for (k=0; k<1; k++) { // repeat
                sprintf_P(tmp, PSTR("\r\n\r\nDifficulty %d, level %d, repeat %d\r\n"), i, j, k);
                soft_uart_puts(tmp);
                generate_pattern(i, j, pattern, leds);
                print_pattern(pattern);
                print_leds();
            }
        }
    }
}

void print_pattern(matrix_t data) {
    int i, j;
    char tmp[20];
    
    soft_uart_puts_P(PSTR("\r\nSet Pattern\r\n     0   1   2   3   4   5   6   7\r\n\r\n"));

    for (i=0; i<SIZE-1; i++) {
        sprintf_P(tmp, PSTR("%d: "), i);
        soft_uart_puts(tmp);
        for (j=0; j<SIZE; j++) {
            if ( j<=i ) {
                sprintf_P(tmp, PSTR("    "));
            } else {
                sprintf_P(tmp, PSTR("%3d "), data[i][j] );
            }
            soft_uart_puts(tmp);
        }
        soft_uart_puts_P(PSTR("\r\n"));
    }
}

void print_leds(void) {
    int i;
    char tmp[20];
    
    soft_uart_puts_P(PSTR("\r\nLEDs\r\n     B   G   R\r\n"));

    for (i=0; i<8; i++) {
        sprintf_P(tmp, PSTR("%d: %3d %3d %3d\r\n"), i, leds[i][0], leds[i][1], leds[i][2]);
        soft_uart_puts(tmp);
    }

}

void print_cal(uint8_t data[SIZE]) {
    int i;
    char tmp[20];
    
    soft_uart_puts_P(PSTR("\r\nADC calibration data\r\n  0   1   2   3   4   5   6   7\r\n"));

    for (i=0; i<8; i++) {
        sprintf_P(tmp, PSTR("%3d "), data[i]);
        soft_uart_puts(tmp);
    }
    sprintf_P(tmp, PSTR("\r\n"));

}
